;/-------------------------\
;| Game Fixer              |
;| DirectDraw Hook Include |
;|                         |
;| Version 0.01            |
;| Date: 28.06.2012        |
;| PureBasic 4.60          |
;|                         |
;| by Thorium              |
;\-------------------------/

EnableExplicit

;object actions
Enumeration 1
  #GF_DD_ObjectCreate
  #GF_DD_ObjectRelease
EndEnumeration

;object types
Enumeration 1
  #GF_DD_IDirectDraw
  #GF_DD_IDirectDraw2
  #GF_DD_IDirectDraw4
  #GF_DD_IDirectDraw7
  #GF_DD_IDirectDrawPalette
  #GF_DD_IDirectDrawClipper
  #GF_DD_IDirectDrawSurface
  #GF_DD_IDirectDrawSurface2
  #GF_DD_IDirectDrawSurface3
  #GF_DD_IDirectDrawSurface4
  #GF_DD_IDirectDrawSurface7
  #GF_DD_IDirectDrawColorControl
  #GF_DD_IDirectDrawGammaControl
EndEnumeration

;IDirectDraw methodes
Enumeration
  #GF_DD_IDD_QueryInterface
  #GF_DD_IDD_AddRef
  #GF_DD_IDD_Release
  #GF_DD_IDD_Compact
  #GF_DD_IDD_CreateClipper
  #GF_DD_IDD_CreatePalette
  #GF_DD_IDD_CreateSurface
  #GF_DD_IDD_DuplicateSurface
  #GF_DD_IDD_EnumDisplayModes
  #GF_DD_IDD_EnumSurfaces
  #GF_DD_IDD_FlipToGDISurface
  #GF_DD_IDD_GetCaps
  #GF_DD_IDD_GetDisplayMode
  #GF_DD_IDD_GetFourCCCodes
  #GF_DD_IDD_GetGDISurface
  #GF_DD_IDD_GetMonitorFrequency
  #GF_DD_IDD_GetScanLine
  #GF_DD_IDD_GetVerticalBlankStatus
  #GF_DD_IDD_Initialize
  #GF_DD_IDD_RestoreDisplayMode
  #GF_DD_IDD_SetCooperativeLevel
  #GF_DD_IDD_SetDisplayMode
  #GF_DD_IDD_WaitForVerticalBlank
EndEnumeration

;IDirectDraw2 methodes
Enumeration
  #GF_DD_IDD2_QueryInterface
  #GF_DD_IDD2_AddRef
  #GF_DD_IDD2_Release
  #GF_DD_IDD2_Compact
  #GF_DD_IDD2_CreateClipper
  #GF_DD_IDD2_CreatePalette
  #GF_DD_IDD2_CreateSurface
  #GF_DD_IDD2_DuplicateSurface
  #GF_DD_IDD2_EnumDisplayModes
  #GF_DD_IDD2_EnumSurfaces
  #GF_DD_IDD2_FlipToGDISurface
  #GF_DD_IDD2_GetCaps
  #GF_DD_IDD2_GetDisplayMode
  #GF_DD_IDD2_GetFourCCCodes
  #GF_DD_IDD2_GetGDISurface
  #GF_DD_IDD2_GetMonitorFrequency
  #GF_DD_IDD2_GetScanLine
  #GF_DD_IDD2_GetVerticalBlankStatus
  #GF_DD_IDD2_Initialize
  #GF_DD_IDD2_RestoreDisplayMode
  #GF_DD_IDD2_SetCooperativeLevel
  #GF_DD_IDD2_SetDisplayMode
  #GF_DD_IDD2_WaitForVerticalBlank
  #GF_DD_IDD2_GetAvailableVidMem
EndEnumeration

;IDirectDraw4 methodes
Enumeration
  #GF_DD_IDD4_QueryInterface
  #GF_DD_IDD4_AddRef
  #GF_DD_IDD4_Release
  #GF_DD_IDD4_Compact
  #GF_DD_IDD4_CreateClipper
  #GF_DD_IDD4_CreatePalette
  #GF_DD_IDD4_CreateSurface
  #GF_DD_IDD4_DuplicateSurface
  #GF_DD_IDD4_EnumDisplayModes
  #GF_DD_IDD4_EnumSurfaces
  #GF_DD_IDD4_FlipToGDISurface
  #GF_DD_IDD4_GetCaps
  #GF_DD_IDD4_GetDisplayMode
  #GF_DD_IDD4_GetFourCCCodes
  #GF_DD_IDD4_GetGDISurface
  #GF_DD_IDD4_GetMonitorFrequency
  #GF_DD_IDD4_GetScanLine
  #GF_DD_IDD4_GetVerticalBlankStatus
  #GF_DD_IDD4_Initialize
  #GF_DD_IDD4_RestoreDisplayMode
  #GF_DD_IDD4_SetCooperativeLevel
  #GF_DD_IDD4_SetDisplayMode
  #GF_DD_IDD4_WaitForVerticalBlank
  #GF_DD_IDD4_GetAvailableVidMem
  #GF_DD_IDD4_GetSurfaceFromDC
  #GF_DD_IDD4_RestoreAllSurfaces
  #GF_DD_IDD4_TestCooperativeLevel
  #GF_DD_IDD4_GetDeviceIdentifier
EndEnumeration

;IDirectDraw7 methodes
Enumeration
  #GF_DD_IDD7_QueryInterface
  #GF_DD_IDD7_AddRef
  #GF_DD_IDD7_Release
  #GF_DD_IDD7_Compact
  #GF_DD_IDD7_CreateClipper
  #GF_DD_IDD7_CreatePalette
  #GF_DD_IDD7_CreateSurface
  #GF_DD_IDD7_DuplicateSurface
  #GF_DD_IDD7_EnumDisplayModes
  #GF_DD_IDD7_EnumSurfaces
  #GF_DD_IDD7_FlipToGDISurface
  #GF_DD_IDD7_GetCaps
  #GF_DD_IDD7_GetDisplayMode
  #GF_DD_IDD7_GetFourCCCodes
  #GF_DD_IDD7_GetGDISurface
  #GF_DD_IDD7_GetMonitorFrequency
  #GF_DD_IDD7_GetScanLine
  #GF_DD_IDD7_GetVerticalBlankStatus
  #GF_DD_IDD7_Initialize
  #GF_DD_IDD7_RestoreDisplayMode
  #GF_DD_IDD7_SetCooperativeLevel
  #GF_DD_IDD7_SetDisplayMode
  #GF_DD_IDD7_WaitForVerticalBlank
  #GF_DD_IDD7_GetAvailableVidMem
  #GF_DD_IDD7_GetSurfaceFromDC
  #GF_DD_IDD7_RestoreAllSurfaces
  #GF_DD_IDD7_TestCooperativeLevel
  #GF_DD_IDD7_GetDeviceIdentifier
  #GF_DD_IDD7_StartModeTest
  #GF_DD_IDD7_EvaluateMode
EndEnumeration

;IDirectDrawPalette methods
Enumeration
  #GF_DD_P_QueryInterface
  #GF_DD_P_AddRef
  #GF_DD_P_Release
  #GF_DD_P_GetCaps
  #GF_DD_P_GetEntries
  #GF_DD_P_Initialize
  #GF_DD_P_SetEntries
EndEnumeration

;IDirectDrawClipper methods
Enumeration
  #GF_DD_C_QueryInterface
  #GF_DD_C_AddRef
  #GF_DD_C_Release
  #GF_DD_C_GetClipList
  #GF_DD_C_GetHWnd
  #GF_DD_C_Initialize
  #GF_DD_C_IsClipListChanged
  #GF_DD_C_SetClipList
  #GF_DD_C_SetHWnd
EndEnumeration

;IDirectDrawSurface methods
Enumeration
  #GF_DD_IDDS_QueryInterface
  #GF_DD_IDDS_AddRef
  #GF_DD_IDDS_Release
  #GF_DD_IDDS_AddAttachedSurface
  #GF_DD_IDDS_AddOverlayDirtyRect
  #GF_DD_IDDS_Blt
  #GF_DD_IDDS_BltBatch
  #GF_DD_IDDS_BltFast
  #GF_DD_IDDS_DeleteAttachedSurface
  #GF_DD_IDDS_EnumAttachedSurfaces
  #GF_DD_IDDS_EnumOverlayZOrders
  #GF_DD_IDDS_Flip
  #GF_DD_IDDS_GetAttachedSurface
  #GF_DD_IDDS_GetBltStatus
  #GF_DD_IDDS_GetCaps
  #GF_DD_IDDS_GetClipper
  #GF_DD_IDDS_GetColorKey
  #GF_DD_IDDS_GetDC
  #GF_DD_IDDS_GetFlipStatus
  #GF_DD_IDDS_GetOverlayPosition
  #GF_DD_IDDS_GetPalette
  #GF_DD_IDDS_GetPixelFormat
  #GF_DD_IDDS_GetSurfaceDesc
  #GF_DD_IDDS_Initialize
  #GF_DD_IDDS_IsLost
  #GF_DD_IDDS_Lock
  #GF_DD_IDDS_ReleaseDC
  #GF_DD_IDDS_Restore
  #GF_DD_IDDS_SetClipper
  #GF_DD_IDDS_SetColorKey
  #GF_DD_IDDS_SetOverlayPosition
  #GF_DD_IDDS_SetPalette
  #GF_DD_IDDS_Unlock
  #GF_DD_IDDS_UpdateOverlay
  #GF_DD_IDDS_UpdateOverlayDisplay
  #GF_DD_IDDS_UpdateOverlayZOrder
EndEnumeration

;IDirectDrawSurface2 methodes
Enumeration
  #GF_DD_IDDS2_QueryInterface
  #GF_DD_IDDS2_AddRef
  #GF_DD_IDDS2_Release
  #GF_DD_IDDS2_AddAttachedSurface
  #GF_DD_IDDS2_AddOverlayDirtyRect
  #GF_DD_IDDS2_Blt
  #GF_DD_IDDS2_BltBatch
  #GF_DD_IDDS2_BltFast
  #GF_DD_IDDS2_DeleteAttachedSurface
  #GF_DD_IDDS2_EnumAttachedSurfaces
  #GF_DD_IDDS2_EnumOverlayZOrders
  #GF_DD_IDDS2_Flip
  #GF_DD_IDDS2_GetAttachedSurface
  #GF_DD_IDDS2_GetBltStatus
  #GF_DD_IDDS2_GetCaps
  #GF_DD_IDDS2_GetClipper
  #GF_DD_IDDS2_GetColorKey
  #GF_DD_IDDS2_GetDC
  #GF_DD_IDDS2_GetFlipStatus
  #GF_DD_IDDS2_GetOverlayPosition
  #GF_DD_IDDS2_GetPalette
  #GF_DD_IDDS2_GetPixelFormat
  #GF_DD_IDDS2_GetSurfaceDesc
  #GF_DD_IDDS2_Initialize
  #GF_DD_IDDS2_IsLost
  #GF_DD_IDDS2_Lock
  #GF_DD_IDDS2_ReleaseDC
  #GF_DD_IDDS2_Restore
  #GF_DD_IDDS2_SetClipper
  #GF_DD_IDDS2_SetColorKey
  #GF_DD_IDDS2_SetOverlayPosition
  #GF_DD_IDDS2_SetPalette
  #GF_DD_IDDS2_Unlock
  #GF_DD_IDDS2_UpdateOverlay
  #GF_DD_IDDS2_UpdateOverlayDisplay
  #GF_DD_IDDS2_UpdateOverlayZOrder
  #GF_DD_IDDS2_GetDDInterface
  #GF_DD_IDDS2_PageLock
  #GF_DD_IDDS2_PageUnlock
EndEnumeration

;IDirectDrawSurface3 methodes
Enumeration
  #GF_DD_IDDS3_QueryInterface
  #GF_DD_IDDS3_AddRef
  #GF_DD_IDDS3_Release
  #GF_DD_IDDS3_AddAttachedSurface
  #GF_DD_IDDS3_AddOverlayDirtyRect
  #GF_DD_IDDS3_Blt
  #GF_DD_IDDS3_BltBatch
  #GF_DD_IDDS3_BltFast
  #GF_DD_IDDS3_DeleteAttachedSurface
  #GF_DD_IDDS3_EnumAttachedSurfaces
  #GF_DD_IDDS3_EnumOverlayZOrders
  #GF_DD_IDDS3_Flip
  #GF_DD_IDDS3_GetAttachedSurface
  #GF_DD_IDDS3_GetBltStatus
  #GF_DD_IDDS3_GetCaps
  #GF_DD_IDDS3_GetClipper
  #GF_DD_IDDS3_GetColorKey
  #GF_DD_IDDS3_GetDC
  #GF_DD_IDDS3_GetFlipStatus
  #GF_DD_IDDS3_GetOverlayPosition
  #GF_DD_IDDS3_GetPalette
  #GF_DD_IDDS3_GetPixelFormat
  #GF_DD_IDDS3_GetSurfaceDesc
  #GF_DD_IDDS3_Initialize
  #GF_DD_IDDS3_IsLost
  #GF_DD_IDDS3_Lock
  #GF_DD_IDDS3_ReleaseDC
  #GF_DD_IDDS3_Restore
  #GF_DD_IDDS3_SetClipper
  #GF_DD_IDDS3_SetColorKey
  #GF_DD_IDDS3_SetOverlayPosition
  #GF_DD_IDDS3_SetPalette
  #GF_DD_IDDS3_Unlock
  #GF_DD_IDDS3_UpdateOverlay
  #GF_DD_IDDS3_UpdateOverlayDisplay
  #GF_DD_IDDS3_UpdateOverlayZOrder
  #GF_DD_IDDS3_GetDDInterface
  #GF_DD_IDDS3_PageLock
  #GF_DD_IDDS3_PageUnlock
  #GF_DD_IDDS3_SetSurfaceDesc
EndEnumeration

;IDirectDrawSurface4 methodes
Enumeration
  #GF_DD_IDDS4_QueryInterface
  #GF_DD_IDDS4_AddRef
  #GF_DD_IDDS4_Release
  #GF_DD_IDDS4_AddAttachedSurface
  #GF_DD_IDDS4_AddOverlayDirtyRect
  #GF_DD_IDDS4_Blt
  #GF_DD_IDDS4_BltBatch
  #GF_DD_IDDS4_BltFast
  #GF_DD_IDDS4_DeleteAttachedSurface
  #GF_DD_IDDS4_EnumAttachedSurfaces
  #GF_DD_IDDS4_EnumOverlayZOrders
  #GF_DD_IDDS4_Flip
  #GF_DD_IDDS4_GetAttachedSurface
  #GF_DD_IDDS4_GetBltStatus
  #GF_DD_IDDS4_GetCaps
  #GF_DD_IDDS4_GetClipper
  #GF_DD_IDDS4_GetColorKey
  #GF_DD_IDDS4_GetDC
  #GF_DD_IDDS4_GetFlipStatus
  #GF_DD_IDDS4_GetOverlayPosition
  #GF_DD_IDDS4_GetPalette
  #GF_DD_IDDS4_GetPixelFormat
  #GF_DD_IDDS4_GetSurfaceDesc
  #GF_DD_IDDS4_Initialize
  #GF_DD_IDDS4_IsLost
  #GF_DD_IDDS4_Lock
  #GF_DD_IDDS4_ReleaseDC
  #GF_DD_IDDS4_Restore
  #GF_DD_IDDS4_SetClipper
  #GF_DD_IDDS4_SetColorKey
  #GF_DD_IDDS4_SetOverlayPosition
  #GF_DD_IDDS4_SetPalette
  #GF_DD_IDDS4_Unlock
  #GF_DD_IDDS4_UpdateOverlay
  #GF_DD_IDDS4_UpdateOverlayDisplay
  #GF_DD_IDDS4_UpdateOverlayZOrder
  #GF_DD_IDDS4_GetDDInterface
  #GF_DD_IDDS4_PageLock
  #GF_DD_IDDS4_PageUnlock
  #GF_DD_IDDS4_SetSurfaceDesc
  #GF_DD_IDDS4_SetPrivateData
  #GF_DD_IDDS4_GetPrivateData
  #GF_DD_IDDS4_FreePrivateData
  #GF_DD_IDDS4_GetUniquenessValue
  #GF_DD_IDDS4_ChangeUniquenessValue
EndEnumeration

;IDirectDrawSurface7 methodes
Enumeration
  #GF_DD_IDDS7_QueryInterface
  #GF_DD_IDDS7_AddRef
  #GF_DD_IDDS7_Release
  #GF_DD_IDDS7_AddAttachedSurface
  #GF_DD_IDDS7_AddOverlayDirtyRect
  #GF_DD_IDDS7_Blt
  #GF_DD_IDDS7_BltBatch
  #GF_DD_IDDS7_BltFast
  #GF_DD_IDDS7_DeleteAttachedSurface
  #GF_DD_IDDS7_EnumAttachedSurfaces
  #GF_DD_IDDS7_EnumOverlayZOrders
  #GF_DD_IDDS7_Flip
  #GF_DD_IDDS7_GetAttachedSurface
  #GF_DD_IDDS7_GetBltStatus
  #GF_DD_IDDS7_GetCaps
  #GF_DD_IDDS7_GetClipper
  #GF_DD_IDDS7_GetColorKey
  #GF_DD_IDDS7_GetDC
  #GF_DD_IDDS7_GetFlipStatus
  #GF_DD_IDDS7_GetOverlayPosition
  #GF_DD_IDDS7_GetPalette
  #GF_DD_IDDS7_GetPixelFormat
  #GF_DD_IDDS7_GetSurfaceDesc
  #GF_DD_IDDS7_Initialize
  #GF_DD_IDDS7_IsLost
  #GF_DD_IDDS7_Lock
  #GF_DD_IDDS7_ReleaseDC
  #GF_DD_IDDS7_Restore
  #GF_DD_IDDS7_SetClipper
  #GF_DD_IDDS7_SetColorKey
  #GF_DD_IDDS7_SetOverlayPosition
  #GF_DD_IDDS7_SetPalette
  #GF_DD_IDDS7_Unlock
  #GF_DD_IDDS7_UpdateOverlay
  #GF_DD_IDDS7_UpdateOverlayDisplay
  #GF_DD_IDDS7_UpdateOverlayZOrder
  #GF_DD_IDDS7_GetDDInterface
  #GF_DD_IDDS7_PageLock
  #GF_DD_IDDS7_PageUnlock
  #GF_DD_IDDS7_SetSurfaceDesc
  #GF_DD_IDDS7_SetPrivateData
  #GF_DD_IDDS7_GetPrivateData
  #GF_DD_IDDS7_FreePrivateData
  #GF_DD_IDDS7_GetUniquenessValue
  #GF_DD_IDDS7_ChangeUniquenessValue
  #GF_DD_IDDS7_SetPriority
  #GF_DD_IDDS7_GetPriority
  #GF_DD_IDDS7_SetLOD
  #GF_DD_IDDS7_GetLOD
EndEnumeration

;IDirectDrawColorControl methods
Enumeration
  #GF_DD_CC_QueryInterface
  #GF_DD_CC_AddRef
  #GF_DD_CC_Release
  #GF_DD_CC_GetColorControls
  #GF_DD_CC_SetColorControls
EndEnumeration

;IDirectDrawGammaControl methods
Enumeration
  #GF_DD_GC_QueryInterface
  #GF_DD_GC_AddRef
  #GF_DD_GC_Release
  #GF_DD_GC_GetGammaRamp
  #GF_DD_GC_SetGammaRamp
EndEnumeration

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 34
; FirstLine = 12
; EnableXP